/* Sistemas Integrados TEKNISA
   Gesto de Qualificao

Nome: 8570_QFOSTPO.sql

Descrio:
Updata a qualificao de marca por produto para um teste de produto pai   
e para os testes filhos.                                               

Criao:
21/11/2000 Joo Fernando dos Reis Corra
*/

CREATE OR REPLACE PROCEDURE UPDATE_QFOMARPROD
   (P_NRTESTEPROD IN TESTEPROD.NRTESTEPROD%TYPE,
    P_UTILIZAREND IN VARCHAR2 DEFAULT NULL) IS

   V_DTVALAPRTEST TESTEPROD.DTVALAPRTEST%TYPE;
   V_DTTESTE      TESTEPROD.DTTESTE%TYPE;
   V_IDMARCAPRTES TESTEPROD.IDMARCAPRTES%TYPE;
   V_VRRENDATUTES TESTEPROD.VRRENDATUTES%TYPE;
   V_NRTESTEPROD  TESTEPROD.NRTESTEPROD%TYPE;
   V_COUNT        NUMBER;

BEGIN
/* VALORES DO TESTE PAI QUE SERAO ATUALIZADOS NOS TESTES FILHOS */
   SELECT
      MAX(DTVALAPRTEST),
      MAX(DTTESTE),
      MAX(IDMARCAPRTES),
      MAX(VRRENDATUTES),
      MAX(NRTESTEPROD)
      INTO
      V_DTVALAPRTEST,
      V_DTTESTE,
      V_IDMARCAPRTES,
      V_VRRENDATUTES,
      V_NRTESTEPROD
   FROM
      TESTEPROD
   WHERE
      NRTESTEPROD = P_NRTESTEPROD;

/* UPDATA A QUALIFICACAO DO TESTE PAI E DOS FILHOS */
   FOR C_TESTEFILHO IN
   (SELECT
      CDPRODUTO,
      CDMARCA,
      NRTESTEPROD
   FROM
      TESTEPROD
   WHERE
      NRTESTEPROD  = P_NRTESTEPROD OR
      NRTESPRDORIG = P_NRTESTEPROD)
   LOOP
      V_COUNT := 0;
      SELECT
        COUNT(*) INTO V_COUNT
      FROM
        PRODUTO
      WHERE
        CDPRODESTO = C_TESTEFILHO.CDPRODUTO;

      IF V_COUNT = 0 THEN
         BEGIN
            UPDATE QFOMARPROD
               SET DTVALAPROVA  = V_DTVALAPRTEST,
                   DTTESTEQUA   = V_DTTESTE,
                   IDAPRMARPRO  = V_IDMARCAPRTES,
                   VRRENDATU    = DECODE(P_UTILIZAREND, 'S', V_VRRENDATUTES, 'X', NULL, VRRENDATU),
                   IDAUTMARPRO  = 'N',
                   NRTESTEPROD  = C_TESTEFILHO.NRTESTEPROD
               WHERE
                  CDPRODUTO   = C_TESTEFILHO.CDPRODUTO AND
                  CDMARCA     = C_TESTEFILHO.CDMARCA;

            IF SQL%NOTFOUND THEN
               INSERT INTO QFOMARPROD (CDMARCA,     CDPRODUTO,  NRTESTEPROD,
                                       DTVALAPROVA, DTTESTEQUA, IDAPRMARPRO,
                                       VRRENDATU,   IDAUTMARPRO)
               VALUES (C_TESTEFILHO.CDMARCA, C_TESTEFILHO.CDPRODUTO, C_TESTEFILHO.NRTESTEPROD,
                       V_DTVALAPRTEST, V_DTTESTE, V_IDMARCAPRTES,
                       DECODE(P_UTILIZAREND, 'S', V_VRRENDATUTES, 'X', NULL, 0), 'N');
            END IF;
         END;
      ELSE
         FOR C_PRODSESTO IN
          (SELECT
             CDPRODUTO
           FROM
             PRODUTO
           WHERE
             CDPRODESTO = C_TESTEFILHO.CDPRODUTO)
         LOOP
            BEGIN
               UPDATE QFOMARPROD
                  SET DTVALAPROVA  = V_DTVALAPRTEST,
                      DTTESTEQUA   = V_DTTESTE,
                      IDAPRMARPRO  = V_IDMARCAPRTES,
                      VRRENDATU    = DECODE(P_UTILIZAREND, 'S', V_VRRENDATUTES, 'X', NULL, VRRENDATU),
                      IDAUTMARPRO  = 'N',
                      NRTESTEPROD  = C_TESTEFILHO.NRTESTEPROD
                  WHERE
                     CDPRODUTO   = C_PRODSESTO.CDPRODUTO AND
                     CDMARCA     = C_TESTEFILHO.CDMARCA;
               IF SQL%NOTFOUND THEN
                  INSERT INTO QFOMARPROD (CDMARCA,     CDPRODUTO,  NRTESTEPROD,
                                          DTVALAPROVA, DTTESTEQUA, IDAPRMARPRO,
                                          VRRENDATU,   IDAUTMARPRO)
                  VALUES (C_TESTEFILHO.CDMARCA, C_PRODSESTO.CDPRODUTO, C_TESTEFILHO.NRTESTEPROD,
                          V_DTVALAPRTEST, V_DTTESTE, V_IDMARCAPRTES,
                          DECODE(P_UTILIZAREND, 'S', V_VRRENDATUTES, 'X', NULL, 0), 'N');
               END IF;
            END;
         END LOOP;
      END IF;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('UPDATE_QFOMARPROD','4.05.096'); END;
/

